<?xml version="1.0" encoding="UTF-8"?>
<stylesheet
	xmlns="http://www.w3.org/1999/XSL/Transform"
	xmlns:xs="http://www.w3.org/2001/XMLSchema"
	xmlns:uct="http://uctool.sf.net/"
	version="2.0">
<import href="Text.xsl" />
<output method="text" />

<param name="merged-file-name" />
<variable name="merged-file" select="document($merged-file-name)" />
<variable name="link-type" select="'multi'" />

<template match="//uct:data-structure">
	<variable name="file-name" select="@code" />
<result-document href="{$file-name}.html">

<value-of select="uct:page-start(concat('#data.structure.page.title# ',@name))" />
<call-template name="data-structure-template" />
<value-of select="uct:page-end()" />

</result-document>
</template>

<template name="data-structure-template">
&lt;a name="data_<value-of select="@code"/>"/>
&lt;h3>#data.structure# <value-of select="@name"/>&lt;/h3>
&lt;span class="label">#code#:&lt;/span> <value-of select="@code"/>
<if test="uct:description">
&lt;div class="label">#description#:&lt;/div><text />
<for-each select="uct:description">
	<if test="not(position()=1)">&lt;br/>
</if>
	<call-template name="text-template" />
</for-each>
</if>
<if test="uct:attribute">
<call-template name="data-structure-att-table-template" />
</if>
<value-of select="uct:data-references-data($merged-file,@code,$link-type)"/>
<value-of select="uct:data-references-uc($merged-file,@code,$link-type)"/>
<call-template name="data-structure-expansion-template" />
</template>

<template match="uct:attribute">
&lt;tr>&lt;td><value-of select="@name"/>&lt;/td>&lt;td><text />
	<value-of select="uct:cell(@code)"/>&lt;/td>&lt;td<text />
	<value-of select="uct:status-hint(@status)"/>><text />
	<value-of select="uct:cell(uct:status(@status))"/>&lt;/td>&lt;td><text />
	<value-of select="uct:cell(uct:data-type(
		@type,@length,@collection,$merged-file,$link-type))"/>
	<text />&lt;/td>&lt;td><value-of select="uct:cell(@description)"/>&lt;/td><text />
<text />&lt;/tr><text />
</template>

<template match="uct:attribute" mode="expand">
	<variable name="type" select="@type" />
	<choose>
	<when test="$merged-file//uct:data-structure[@code=$type and @expand=true()]">
		<apply-templates 
			select="$merged-file//uct:data-structure[@code=$type]/uct:attribute" 
			mode="expand" />
	</when>
	<otherwise>
		<apply-templates select="." />
	</otherwise>
	</choose>
</template>

<template name="data-structure-att-table-template">
<param name="mode" />
&lt;table border="1">
&lt;tr>&lt;td class="label">#name#&lt;/td>&lt;td class="label">#code#&lt;/td><text />
<text />&lt;td class="label">#status#&lt;/td><text />
<text />&lt;td class="label">#type#&lt;/td><text />
<text />&lt;td class="label">#description#&lt;/td>&lt;/tr><text />
<choose>
<when test="$mode='expand'">
	<apply-templates select="uct:attribute" mode="expand" />
</when>
<otherwise>
	<apply-templates select="uct:attribute" />
</otherwise>
</choose>
&lt;/table><text />
</template>

<template name="data-structure-expansion-template">
	<if test="for $att in(uct:attribute) return $merged-file//uct:data-structure[@code=$att/@type and @expand=true()]">
&lt;br/>
&lt;div>&lt;span class="label">#data.structure.expansion#:&lt;/span><text />
		<call-template name="data-structure-att-table-template">
			<with-param name="mode" select="'expand'" />
		</call-template>
	</if>
</template>

</stylesheet>
